﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using UpLoadImg.Utilities;

namespace UpLoadImg.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            return View();
        }

        public JsonResult GetAllUploadImg()
        {
            MVCEntities db = new MVCEntities();
            var model = db.Images.Where(x => x.Id != null).ToList();
            return Json(model, JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetUploadImgById(Image img)
        {
            MVCEntities db = new MVCEntities();
            var model = db.Images.Where(x => x.Id != null).ToList();
            return Json(model, JsonRequestBehavior.AllowGet);
        }

        public ContentResult GetThumbnailImage(Image img)
        {
            string ImgUrl = "~/UpLoad/" + img.ImgName;
            string TempImgUrl="~/Temp/"+img.ImgName;
            Thumbnail.CreateThumbnail(Server.MapPath(ImgUrl), Server.MapPath(TempImgUrl), 96, 96);

            string htmltag = htmltag = "<img id=\"img1\"  src=\"/Temp/" + img.ImgName + "\"/>";
            return Content(htmltag);
        }

        public ContentResult GetImage(Image img)
        {
            string htmltag = htmltag = "<img id=\"img1\"  src=\"/UpLoad/" + img.ImgName + "\"/>";
            return Content(htmltag);
        }
        
        [HttpPost]
        public ContentResult UpLoadFile(HttpPostedFileBase fileData)
        {
            if (fileData != null && fileData.ContentLength > 0)
            {
                string fileSave = Server.MapPath("~/UpLoad/");
                int size = fileData.ContentLength;
                //获取文件的扩展名
                string extName = Path.GetExtension(fileData.FileName);
                //得到一个新的文件名称
                string newName = Guid.NewGuid().ToString() + extName;
                //给模型赋值
                Image img = new Image();
                img.ImgName = newName;
                img.ImgSize = size.ToString() ;
                img.UpLoadTime = System.DateTime.Now;
                //保存图片的同时，保存images的数据的数据库
                MVCEntities db = new MVCEntities();
                db.Images.Add(img);
                db.SaveChanges();

                fileData.SaveAs(Path.Combine(fileSave, newName));
            }
            return Content("");
        }
        public ActionResult UpLoad()
        {
            return View();
        }

    }
}
