﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace UpLoadImg.Utilities
{
    public class Thumbnail
    {
        public static void CreateThumbnail(string source,string destination,int maxWidth,int maxHeight)
        {
            System.Drawing.Image Img = System.Drawing.Image.FromFile(source);
            int Width = Img.Width;
            int Height = Img.Height;
            int thumbnailWidth, thumbnailHeight;

            Resize(Width, Height, maxWidth, maxHeight, out thumbnailWidth, out thumbnailHeight);

            System.Drawing.Bitmap bitmap = new System.Drawing.Bitmap(thumbnailWidth, thumbnailHeight);
            System.Drawing.Graphics graphics = System.Drawing.Graphics.FromImage(bitmap);

            graphics.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;
            graphics.CompositingQuality = System.Drawing.Drawing2D.CompositingQuality.HighQuality;
            graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;

            graphics.DrawImage(Img, 0, 0, thumbnailWidth, thumbnailHeight);
            bitmap.Save(destination);
        }

        private static void Resize(int Width,int Height,int maxWidth,int maxHeight,out int sizedWidth,out int sizedHeight)
        {
            if(Width<maxWidth && Height<maxHeight)
            {
                sizedWidth=Width;
                sizedHeight=Height;
                return ;
            }
            sizedWidth = maxWidth;
            sizedHeight = (int)((double)Height / Width * sizedWidth + 0.5);
            if(sizedHeight>maxHeight)
            {
                sizedHeight = maxHeight;
                sizedWidth = (int)((double)Width / Height * sizedHeight + 0.5);
            }
        }
    }
}